#!/bin/bash

#### Device-Setup ############################################
# Aufruf: device_setup
#
# Variablen:    CLIENT_IP
# Export:       HOSTNAME

## Setze den Hostnamen entsprechend der erhaltenen Wireguard CLIENT_IP
# Variablen:    CLIENT_IP  
change_hostname () {
    NEW_FQDN="$(getent hosts "$CLIENT_IP" | sed 's/\([0-9.]*\)\s*\(.*\)/\2/')"
    NEW_HOSTNAME="$(getent hosts "$CLIENT_IP" | sed 's/\([0-9.]*\)\s*\(.*\)/\2/;s/\([^.]\)\..*/\1/')"
    echo "New Hostname: $NEW_HOSTNAME"
    sed -i "s/127.0.1.1.*/127.0.1.1\t$NEW_HOSTNAME\n\n$CLIENT_IP\t$NEW_FQDN $NEW_HOSTNAME/g" /etc/hosts
    echo "$NEW_HOSTNAME" > /etc/hostname
    export HOSTNAME="$NEW_HOSTNAME"
}

## Device einrichten
# Variablen:    CLIENT_IP
# Export:       HOSTNAME
device_setup () {
    check_done "device_setup" && return 0
    # Use CLIENT_IP of wg0 interface if CLIENT_IP is not set
    # This happens if wg_setup was done in a script run before but device_setup failed
    if ! [ -v CLIENT_IP ]
    then
        CLIENT_IP=$(hostname -I | grep '10\.5\.25[23]' | sed 's/.*\(10\.5\.25[23]\.[[:digit:]]\{1,3\}\).*/\1/')
    fi
    change_hostname \
    && [ -n "$CLIENT_META_PKG_BASE" ] && install_pkg "${CLIENT_META_PKG_BASE}-${HOSTNAME}-meta" \
    && mark_done "device_setup"
}

#### Device-Setup - Ende #####################################
